<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 17/06/19
 * Time: 17.24
 */

namespace FiloBlu\RmaAdditionalData\Plugin;
use Magento\Framework\App\Config\ScopeConfigInterface;

class AddCustomCarrier
{

    protected $scopeConfig;
    const RMA_CUSTOM_CARRIER = 'filoblu_disablerma_section/rma_group/rma_option_carrier';

    /**
     * AddCustomCarrier constructor.
     * @param ScopeConfigInterface $scopeConfig
     */
    public function __construct(ScopeConfigInterface $scopeConfig)
    {
        $this->scopeConfig = $scopeConfig;
    }


    /**
     * @param \Magento\Rma\Block\Returns\View $subject
     * @param $result
     * @return mixed
     */
    public function afterGetCarriers(\Magento\Rma\Block\Returns\View $subject, $result)
    {
        if($this->scopeConfig->getValue(self::RMA_CUSTOM_CARRIER) ?? 0)
        {
            $carriers['custom'] = "Custom";
            $result = array_merge($carriers,$result);
        }
        return $result;
    }


    /**
     * @param \Magento\Rma\Block\Returns\View $subject
     */
    public function beforeToHtml(\Magento\Rma\Block\Returns\View $subject)
    {
        $template = $subject->getTemplate();
        if ($template === 'return/view.phtml' && $this->scopeConfig->getValue(self::RMA_CUSTOM_CARRIER) ?? 0) {
            $subject->setTemplate('FiloBlu_RmaAdditionalData::return/view.phtml');
        }
        return;
    }


}